# Daily Journal

## March 5th

## March 5th
Forgot to update journal the past few days. What I have done is set up a mobile and desktop react page to display the logged in user's tasks. The reason I created two different pages was 1st I did not want to include a desktop version and a mobile version on the same page and control which was displayed using a display none property using css because the data would be generated twice. Also I wanted to use a table format for the desktop version and I knew that using table for a mobile device would be difficult due to the size of each individual row. Instead I set up a variable that is set using a useEffect that listens to changes in screen size. Depending on this variable the desktop or mobile version will return none and the rest of the code will not execute. The opposite page will be displayed on the page. 

I also set up the filter options and order by options using a util file that decides based on the user's selection which Task view to use. This along with a fetch file generates the  data. A big issue I ran into with this portion of the project was not realizing that the GET method cannot contain body data. I breifly considered changing the request to a POST request however I after some brief researching I found out this was bad practice. I then changed the urls to include dynamic information such as user_id, desired_order, various priorities and statuses (based on the view that was being called). I then checked that all of these views worked via insomnia and finally got to finsihing the util file that decides the url to reach the backend, this time including the variable data within the url. 

Completed most of the frontend pages including the update and create task page. 

I also completed the rabbitmq consumer and function that updates user spendable points and lifetime points on task completion. Also regarding the user model I added a reward property as a manytomanyfield to the newly created Reward model. Included views to add a reward to a selected user depending if they have enough spendable_points and also updating spendable_points property on purchase.

## Feb 28th 
Began working on the front end, set up the user context which is populated from the authorization file which includes, login, signup, and logout functions using djwto's backend and some custom User view functions. The user context was set up at the App level in order for the useEffect to be called during any change to the username variable which is populated from the authorization file. May look into transferring this into the context file itself.
## Feb 25th
Wrote the combination views for the task model. Tested each of them using insomnia. Realized that I should included a deleted property on the Task model in order to keep the data when a user wants to delete it. Had to create a new helper function that filters out deleted tasks and copy and paste the code onto each view function.

Today involved a lot of careful repetition and url checking, but I finally see the application coming together and taking shape.

Next steps are to set up a new rabbitmq connection that on marking a task complete adjust the user's lifetime and spendable points in the user microservice. Begin working on the frontend, then set up the Reward and Notification models in the user and task microservice respectively. Begin looking into automated testing.

## Feb 23rd
Started with writing the views for the tasks microservice. First created the encoders for Task, Status, and Priority. Then created fixtures to create the 3 status and priority types, include the command python manage.py loaddata for both json files to the Task microservice Dockerfile.dev. While writing the task_list view I realized that the completed_date property on the Task model was not set to null=True, the completed_date should be set to null since when a task is added it will rarely be completed. I also realized that the information I would be sending through would likely not be model instances for status, priority, and user. I could find a way to include the actual instances of status and priority but user would be more difficult because the logged in user will technically be a user instance from the User microservice. If I have time I will see if there would be a way to do it more dynamically. Another reason I did it this way was for testing with Insomnia where it would be much more complicated than sending saved information from the frontend. For the time being I query the database for the user, status, and priority that match the ids passed through json. Then I delete the the ids from the content that was pulled of the request.body by json.loads() and repopulate those fields with the instances from the querysets. Then I spread the updated content through using kwargs.

Wrote all of the task helper functions and then wrote the basic task view functions, will write the combination view functions tomorrow. All views were tested to make sure they worked.

## Feb 22nd
Began writing the views for the User microservice. While attempting to create a new user using insomnia I ran into an error on the Postgresql container I had not seen before, it was Error: value too long for type character varying(1). Because I thought the 1 meant at index 1 and password was at index 1 and it was very long I thought something was wrong with the hashing. When I realized this was not the case I thought it might be something to do with the fields I inherited from AbstractUser maybe one of them didn't allow for longer values. It wasn't until I had looked over my model that I realized I had set max_length on username to 1. Decided to include a helper function that determines if the username provided for a post has already been taken. Will use this on the frontend to let the user no that the need to select a new username.

Ran into an issue with my encoder where the UUIDField would not convert to Json I attempted to write a new encoder for it. I imported UUIDField into the encoder file and set up an encoder that would convert it into a integer. This did not work though and I didn't want to waste too much time so I removed my migrations for the task application (because Docker does not allow you to set a default the container just fails and I had already converted my database to a DATABASE_URL in preparation for Heroku and it seemed like too many steps) and applied migrations again with a PositiveBigIntegerField.

Completed the views for the user microservice, decided to keep the user information on deletion and change is_active property to False. I have read this is good practice because it allows an application to keep data about a user after they have deactivated their account.

Set up Rabbitmq to send user data to the task microservice (will use this when it comes time to create tasks and need to assign them to a user) to set up a UserVO instance.

## Feb 21st
Set up and created Django Users and Tasks microservices as well as a React frontend. Linked the applications to projects through urls.py and INSTALLED_APPS. Removed sqlite database configurations in settings.py files for Django projects and set up Heroku's database specifications. In settings.py file included corsheader and djwto in the INSTALLED_APPS in order to allow for interaction with React frontend and user jwt creation respectively. Updated ALLOWED_HOSTS and CORES_ALLOWED_ORIGINS in order to allow the frontend to be accepted by Django and in preparation for hosting. 

Included common folder with encoder files in the Django projects that will be used to transfer data into Json acceptable format. Created User, Task, Status, Priority and UserVO models. Include requirements.txt files to the two Django microservices as well as Dockerfile.dev. Created a docker-compose.yml file for the React frontend, Django microservices and Rabbitmq. 

Included a windows-setup.js file on the frontend that allows for better React updates in the browser in relation to code updates on Windows. Added a run.sh file that is ran via the Docker compose that installs React dependencies and starts the React application. Added a relational-data directory which dynamically creates the databases for Postgresql for the Django backend microservices via a Dockerfile.dev and docker-compose.yml.

Researched websockets using Chatgpt and Stackoverflow as this is something I have not worked with before. Briefly considered using Django Signals as an option until I realized that it is not a websocket. However, am keeping Django signals in mind in case I run out of time when implementing a proper websocket such as Django Channels. Thinking of using the websocket for notifications of upcoming or past due tasks.


# Feb 20th
Diagramed the microservices, decided that Users and Tasks would for sure be their own microservices whereas prizes and notifications may reside in their own microservice or another. Drew up the basic models for tasks, users, status and priority. Realized that that fixtures will have to be created for status (to-do, in-progress, completed) and priority (urgent, important, unimportant). Drew up branch diagrams for the task view to filter individual priorities, statuses, users, upcoming, specific date, and order. Realized that I need to create dynamic views but wanted to still have specific view if one or many of the filters were not activated because specific views provide better logic control and future reconfiguration. Narrowed it down to 22 filter views that will use helper functions in order to reduce code repetition. Wrote out these helper functions in my notebook as well as the way the views will incorporate them. Decide to use React as the frontend to show a little of frontend understanding (I think it is somewhat important to understand how frontend developers use the code I write on the backend) and also because I think that it will allow me greater control over my application than using Django templates. Also in the provided documentation for this code challenged it mentioned that part of the assignment was to test the candidate's ability to build a full-stack application.


